unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnAccettaDimensione: TButton;
    BtnCancella: TButton;
    BtnCreaConDatiRandom: TButton;
    BtnCreaConDatiUtente: TButton;
    BtnInizializza: TButton;
    BtnInserimento: TButton;
    BtnMassimo: TButton;
    BtnMedia: TButton;
    BtnMinimo: TButton;
    BtnPulisci: TButton;
    BtnStampa: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    procedure BtnAccettaDimensioneClick(Sender: TObject);
    procedure BtnCancellaClick(Sender: TObject);
    procedure BtnCreaConDatiRandomClick(Sender: TObject);
    procedure BtnCreaConDatiUtenteClick(Sender: TObject);
    procedure BtnInizializzaClick(Sender: TObject);
    procedure BtnInserimentoClick(Sender: TObject);
    procedure BtnMassimoClick(Sender: TObject);
    procedure BtnMediaClick(Sender: TObject);
    procedure BtnMinimoClick(Sender: TObject);
    procedure BtnPulisciClick(Sender: TObject);
    procedure BtnStampaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

Const MaxComp = 30 ;

Var V : array [1 .. MaxComp] of Integer ;  DimV : Integer;
    i : Integer; p : Integer;  Num : Integer ;
    Min : Integer; Max : Integer; somma : Integer; a : Integer; b : Integer ;
    Media : Single ;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize ;
  For i := 1 To MaxComp do
    ListBox2.Items.Add(IntToStr(i) + '°') ;
end;

procedure TForm1.BtnPulisciClick(Sender: TObject);
begin
  ListBox1.Clear ;
  ListBox3.Clear ;
end;

procedure TForm1.BtnStampaClick(Sender: TObject);
begin
  ListBox1.Clear ;
  For i := 1 To DimV do
    ListBox1.Items.Add(IntToStr(V[i])) ;
end;

procedure TForm1.BtnInizializzaClick(Sender: TObject);
begin
  For i := 1 To MaxComp do
      V[i] := 0 ;
end;

procedure TForm1.BtnInserimentoClick(Sender: TObject);
begin
  Num := StrToInt(Inputbox('','inserisci il valore da aggiungere','')) ;
  DimV := DimV + 1 ;
  V[DimV] := Num  ;
end;

procedure TForm1.BtnMassimoClick(Sender: TObject);
begin
  Max := - maxint ;
  For i := 1 To DimV do
    If V[i] > Max Then
      Max := V[i] ;
  listbox3.items.add('Massimo = ' + IntToStr(Max)) ;
end;

procedure TForm1.BtnMediaClick(Sender: TObject);
begin
  Media := 0  ;
  somma := 0  ;
  For i := 1 To DimV do
    somma := somma + V[i] ;
  Media := somma / DimV  ;
  ListBox3.Items.Add('Media = ' + FloatToStrF(Media,ffFixed,5,2)) ;
end;

procedure TForm1.BtnMinimoClick(Sender: TObject);
begin
  Min := maxint ;
  For i := 1 To DimV do
    If V[i] < Min Then
       Min := V[i] ;
  ListBox3.Items.Add('Minimo = ' + IntToStr(Min)) ;
end;

procedure TForm1.BtnAccettaDimensioneClick(Sender: TObject);
begin
  Repeat
    DimV := StrToInt(Inputbox('','inserisci dimensione','')) ;
  Until (DimV >= 0) And (DimV <= MaxComp)
end;

procedure TForm1.BtnCancellaClick(Sender: TObject);
begin
  p := StrToInt(Inputbox('','inserisci la posizione del valore da cancellare','')) ;
  V[p] := V[DimV] ;
  DimV := DimV - 1 ;
end;

procedure TForm1.BtnCreaConDatiRandomClick(Sender: TObject);
begin
  a := StrToInt(Inputbox('','Inserisci valore minimo','')) ;
  b := StrToInt(Inputbox('','Inserisci valore massimo','')) ;
  For i := 1 To DimV do
    V[i] := Random(b - a + 1) + a  ;
end;

procedure TForm1.BtnCreaConDatiUtenteClick(Sender: TObject);
begin
  For i := 1 To DimV do
    V[i] := StrToInt(Inputbox('','inserisci la componente di posto ' + IntToStr(i),'')) ;
end;



end.

